
import os, sys

shareddir=os.path.join(os.getcwd(),'src')
sys.path.append(shareddir)
    
from eventmgr import eventmgr
from UniqueId import UniqueId 

import math

import cPickle as pickle

from gamebase import *
from gui import *

import random


appendmodelpath(os.path.join(os.getcwd(),'resources'))


#STONETEX='stone16.png' 
HENTEX1='hen128_b1.png'
HENTEX2='hen128_b2.png'
WALLTEX='blue128.jpg'
WALLHOLETEX='blueholes128.png'

#BGTILETEX='bgtile128.jpg'
#TILETEX='tile128.jpg'
#ARROWBLACKTEX='arrowblack128.png'
#ARROWWHITETEX='arrowwhite128.png'
#SMALLARROWTEX='arrow32.png'
GRIDTEX='grid128-b.png'
EXITTEX='exit128.jpg'
EGGTEX='egg64.png'
FEATHERTEX='feather_y.png'
#DOTTEX='blackborderdot16-g.png'
TILECURSORTEX='tilecursor64.png'
PLAYERSTARTTEX='playerstart128.png'

HENTEXS=(loader.loadTexture(HENTEX1),loader.loadTexture(HENTEX2))
for i in HENTEXS:
    i.setMinfilter(Texture.FTLinearMipmapLinear)
    i.setWrapU(Texture.WMClamp)
    i.setWrapV(Texture.WMClamp)
    assert(i<>None)

#GRAVBLOCKTEXS=(loader.loadTexture(TILETEX),loader.loadTexture(WALLTEX))
#for i in GRAVBLOCKTEXS: assert(i<>None)
        
#ARROWTEXS=[loader.loadTexture(ARROWBLACKTEX),loader.loadTexture(ARROWWHITETEX)]
#for i in ARROWTEXS: assert(i<>None)
        
BLOCKTEXS=(loader.loadTexture(WALLHOLETEX),loader.loadTexture(WALLTEX))
for i in BLOCKTEXS: assert(i<>None)        
     


class keymenu(frame):
    def __init__(self,parent,key,toggle=False,frameargs={},widgetargs={}):
        widgetargs['zbias']=50
        frameargs['widgetargs']=widgetargs
        frame.__init__(self,parent,**frameargs)
        self.key=key
        self.bind('onfree',self._onfree)
        self.bind('onsetvisible',self._onsetvisible)
        
        self.keybind=keybinder(self,True)
        self.keybind.addkey(key)
        self.keybind.bind('onkeydown-'+key,self._onkey,True,True)
        self.keybind.bind('onkeyup-'+key,self._onkey,False,True)        
        
        self.toggle=toggle
     
    def _onsetvisible(self,visible): pass
#        if not visible:
#            self.parent.setplaymode('player')
    
    def setenabled(self,enabled):        
        self.keybind.setenabled(enabled)      
        
    def _onhide(self): pass
        
    def _onkey(self,down):        
        if down:            
            self.togglevisible()
            if not self.visible:
                self._onhide()
        else:
            if self.toggle and self.visible:                
                self.togglevisible()
                self._onhide()
             

    def _onfree(self):
        self.keybind.free()
        

class mainmenu(keymenu):
    def __init__(self,parent):
        
        frameargs={'bordersize':0,
                   'bgcolor':VBase4(0.15,0.63,0.9,1),
                   }
        widgetargs={'layout':[100,100],
                   'size':[0,0],                                      
                   }

        keymenu.__init__(self,parent,key='tab',frameargs=frameargs,widgetargs=widgetargs)
        
        widgetargs={'layout':layoutclass('nc',[100,0]),
                    'size':[0,64],
                    'pos':[0,-16],
                    }
        
        self.frame=frame(self,widgetargs=widgetargs,bgcolor=VBase4(0.8,0.3,0.3,1),borders=BORDERNOTOPSHADOW32,bordercolor=VBase4(0.8,0.3,0.3,1),bordersize=16).init()

        self.title=label(self.frame,text='Mother Feather Plucker',                         
                         widgetargs={'layout':'nw','size':[40,40],'pos':[18,8]},
                         align='left').init()
        
        bs=copydict(BUTTONSTYLE1)
        bs[BNORMAL]['bg']=VBase4(0.9,0.9,0.5,1)
                         
        self.playbutton=button(self.frame,text='PLAY',                              
                               buttonstyle=bs, 
                               labelargs={'align':'left','widgetargs':{'layout':layoutclass('nw',[-65,65]),'size':[0,0],'pos':[7+5,-1+3]}},
                               frameargs={'bordersize':10,'borders':BORDERSSHADOW32},
                               widgetargs={'layout':'nw','size':[80+15-11,33+16-8],'pos':[350+40,19-8+4]},
                               ).init()                                                                
        self.playbutton.bind('onclick',self.togglevisible)
        
        txt1="""
__Player Controls__

 W or Space - Jump
 A - Run Left
 D - Run Right
 S - Fall Faster
 
 Arrow Keys - Shoot Feather

__Game Controls__

 R - Restart the Level
 Enter - Next level 
 Backspace - Previous Level     
 
      
 Tab - Toggle this Main Menu     
 1 - Toggele Level Editor

 F11 - Toggle Fullscreen (buggy)                
 Escape - Close the Game         
 
__Level Editor Controls__

Left Click - copy/move selected tile 
Right Click - set selected tile
Middle Click or Left Click + X - clear selected tile
"""
        

        self.instruct=label(self,text=txt1,
                            fgcolor=Vec4(0,0,0,1),
                            shadowcolor=Vec4(0,0,0,0.5),
                            
                            align='left',
                            widgetargs={'layout':'nw','size':[14,14],'pos':[30,30]},                            
                            ).init()
        
                            
        txt2="""        
Story:

One day a small piece of a meteorite fell into a barn and contaminated the food of an angry hen who has been waiting for revenge.
Nicknamed "The Feather Plucker", our heroine escapes from captivity on a farm in search of her stolen eggs.
Armed with only the feathers on her back she bravely sets out on a quest to save her young from the hungry clutches of the carnivorus humans.
"""
        self.instruct=label(self,text=txt2,
                            fgcolor=Vec4(0,0,0,1),
                            shadowcolor=Vec4(0,0,0,0.5),
                                
                            align='left',
                            widgetargs={'layout':'nw','size':[17,17],'pos':[420,30]},                            
                            ).init()
     
        #self.parent.bind('onenabled',self._onparentenabled)
        #self.parent.bind('ondisabled',self._onparentdisabled)      
                                              
        
        #self._togglevisible()
        
    def _onsetvisible(self,visible):
        if visible:
            self.parent.setplaymode('mainmenu')
        else:
            self.parent.setplaymode('player')
    
        
#    def _onhide(self):        
         
#        self.parent.setplaymode('player')
           
class levelclass(feature):
    def __init__(self,parent):
        feature.__init__(self,parent)
        self.bind('onfree',self._onfree)     
        self.root.bind('onsim',self._update)
               
    def save(self):
        self._savelevel()
        
    def load(self):            
        self._loadlevel()
        self.notify('onload',False,None) 
        
    def unload(self):
        self.notify('onunload',False,None)
        self._unloadlevel()
        
    def _onfree(self):
        self.notify('onunload',False,None)
        self._unloadlevel()
        
    def _unloadlevel(self): pass
    
    def _savelevel(self): pass
        
    def _loadlevel(self): pass
        
    def _update(self,dt):
        pass
    
 
class leveldata:
    def __init__(self):
        self.initialized=False
        self.loaded=False
        
        self.tiledata={}
        
        
    #def _onafterload(self): pass
    #def _onbeforeload(self): pass
        
    def _loadfromfile(self,fname):        
        #self._onbeforeload()
        f=file(fname,'r')
        self.tiledata=pickle.load(f)
        f.close()
        self.loaded=True
        
         
    def _savetofile(self,fname):      
        f=file(fname,'w')
        pickle.dump(self.tiledata,f)
        f.close()
        print 'Level File Saved!'
        
    def _doinitialize(self,level): pass
        
    def initialize(self,level):
        self._doinitialize(level)        
        self.initialized=True
        
    def _douninitialize(self): pass
        
    def uninitialize(self):
        if self.initialized:
            self.initialized=False
            self._douninitialize()            
            self.level=None            
            
    def _dofree(self): pass
        
    def free(self):
        if self.initialized:
            self._dofree()
        self.tiledata={}
        
            
class gameleveldata(leveldata):
    def __init__(self):
        leveldata.__init__(self)      
            
         
#    def _onaddlayer(self,name,order):
#        if not name in self.tiledata:
#            self.tiledata[name]=(order,[])
        
    def _onaddtile(self,data):            
        editing,pos,cls,layer,args=data
        if editing:
            tiles=self.tiledata['tiles'][layer][1]
            tiles.append((pos,cls,args))
            #print 'added tile:',(pos,cls,args)
        
    def _ondeltile(self,tile):        
        layer=tile.layer
        tiles=self.tiledata['tiles'][layer][1]
        for i in xrange(len(tiles)-1,-1,-1):
            pos,cls,params=tiles[i]
            if tile.startpos==pos:                
                tiles.pop(i)
                break
        #print 'tiledata:',repr(self.tiledata)
        #raise Exception('tiledata:'+repr(self.tiledata))
    
    def _doinitialize(self,level):
        level.bind('onaddtile',self._onaddtile)
        level.bind('ondeltile',self._ondeltile)
        
        #print 'loading map:',repr(self.tiledata)
        
        level.setmapsize(*self.tiledata['mapsize'])
        
        for layer,data in self.tiledata['tiles'].iteritems():            
            layersort,piecelist=data
            level.addlayer(layer,layersort)
            #self._onaddlayer(layer,layersort)
            
        for layer,data in self.tiledata['tiles'].iteritems():            
            layersort,piecelist=data
        
            for gridpos,tileclass,tileparams in piecelist:
              
                cd=level.parent.parent.gettileclassdata(tileclass)
                level.addtile(gridpos[0],gridpos[1],cd[0].__name__,layer,tileparams)
        
    def _douninitialize(self):
        pass
                
    def _dofree(self):
        level.unbind('onaddtile',self._onaddtile)
        level.unbind('ondeltile',self._ondeltile)
       
         
       
class loadablelevel(levelclass):
    def __init__(self,parent,name):
        levelclass.__init__(self,parent)     
        
        self.name=name
        
        self.leveldata=gameleveldata()
        
    def _unloadlevel(self):
        self.leveldata.free()    
        self.leveldata=None
   
    def _savelevel(self): 
        fname=os.path.join(os.getcwd(),'levels',self.name+'.pkl')
        self.leveldata._savetofile(fname)
       
        
    def _loadfromfile(self,fname):
        self.leveldata._loadfromfile(fname)        
#        f=file(fname,'r')
#        s=f.read()        
#        f.close()
#        c=compile(s,fname,'exec')
  
#        globs=globals()
#        globs['self']=self
#        exec c in globs
        
        
        
    def _loadlevel(self):
        self.notify('onbeforeload',None,False)
        fname=os.path.join(os.getcwd(),'levels',self.name+'.pkl')
        if os.path.isfile(fname):
            self._loadfromfile(fname)
        else:
            print 'ERROR LOADING LEVEL FILE:',fname
            self._loadtestlevel()     
            
        self.leveldata.initialize(self)
        self.notify('onafterload',None,False)
          
    def _loadtestlevel(self):           
        self.leveldata.tiledata={'mapsize':[50,50],'tiles':{
                                                        'bg':(0,[]),
                                                        'walls':(1,[([1,1],'playerstart',{}),
                                                                    ([2,3],'wallclass',{'stonesolid':False}),
                                                                    ([3,3],'wallclass',{'stonesolid':True}),                                                            
                                                                    ([1,3],'exitblock',{}),
                                                                    ]),
                                                        }}
        
      
    
            
class tilelevel(loadablelevel):
     def __init__(self,parent,name):
        loadablelevel.__init__(self,parent,name)   




class gamelevel(tilelevel):
    def __init__(self,parent,name):
        tilelevel.__init__(self,parent,name)                  
        self.root.bind('onsim',self._onsim)
        
        self.bind('onafterload',self._onafterload)
        self.bind('onbeforeload',self._onbeforeload)
        self.root.gui.bind('onresize',self._rescale)
        
        self.root.gui.bind('onmouse1',self._onmouse,1,True)
        self.root.gui.bind('onmouse2',self._onmouse,2,True)
        self.root.gui.bind('onmouse3',self._onmouse,3,True)
        
        self.levelkeys=keybinder(self)
        self.levelkeys.addkey('x')
        
        self.playerwantstart=[1,1]
        self.playerstart=None
            
        self.enabled=True
              
        self.mousecard=loadcard(self.root.layers['mouse'],texture=TILECURSORTEX,scale=1.35,transparent=True,mipmap=True,autorotate=True)
        self.mousecard.hide()
        
        self.selcard=loadcard(self.root.layers['mouse'],texture=TILECURSORTEX,scale=1.35,transparent=True,mipmap=True,autorotate=True)
        self.selcard.setColor(0.6,0.8,1,1)
        self.selcard.hide()
        
        self.selblink=0
        self.selblinkspeed=10
        self.seltile=None
        
        self.gridcursor=None
        
        self.exitblock=None
        self.gravity=0,-1
        
        self.gravblocks=[]
        
        self.editing=False
        
        self.simulating=False
        
        self.dynamicobjs=[]
        
        #self.scale=1.0/35
        self.scale=1.0/50
        self.campos=[0,0]
        self.camspeed=3
        
        
        self.playeroffset=[-0.4,-0.2]
        self.playerdelta=[0,0]
        
        self.playerpos=[0,0]
        
        self.grid={}
        
        base.cam.setP(-90)
        base.cam.setPos(0,0,1.000001)
        
        self.root.rootnp.setDepthTest(False)
        self.root.rootnp.setDepthWrite(False)
        
        self.defaultmapsize=17,17
        self.mapsize=[0,0]
        self.setmapsize(*self.defaultmapsize)
       
        #self.setediting(True) 
        
        self.activelayer='walls'
        self.seltileindex=-1
        
        
        self.tileinsertcallback=None
        
        def _insert_wall(px,py,self=self):
            return wallclass(self,[px,py])
       
        self.settileinsertcallback(_insert_wall)
       
        
        self._rescale()
    
 
            
        
    def addtile(self,gx,gy,tilecls='wallclass',layer='walls',args=None):
        self._deltile(gx,gy,layer)
        px,py=self._gridtoworld(gx,gy)
        tileclass,deflayer,singleton,defargs=self.parent.parent.gettileclassdata(tilecls)
        if layer==None:
            layer=deflayer
        if args==None:
            args=defargs
        self.grid[layer][gy][gx]=tileclass(self,[px,py],layer,singleton,args)
        self.notify('onaddtile',(self.editing,[gx,gy],tilecls,layer,args))
              
    def _setplayerpos(self,pos):
        if pos<>self.playerpos:
            self.playerpos=pos            
                         
        
    def _resetplayeroffset(self): 
        wx,wy=self.root.gui.windowsize
                
        ar=float(wx)/wy  
        
        s=5.0/ar
              
        if self.parent.parent.player==None:
            sp=[0,0]
            max=[1,1]
        else:
            sp=self.parent.parent.player.speed            
            max=self.parent.parent.player.maxspeed
        spx=s*(1+2*sp[0]/max[0])
        spy=s
        if spx>0: spx*=0.5
                
        dx=self.playeroffset[0]*ar*spx     
        dy=self.playeroffset[1]*spy    
                                
        self.playerdelta=[dx,dy]
        #self.playerdelta=[0,0]
               
    def _resetcamera(self):
        self._resetplayeroffset()        
        px,py=self.playerpos
        px=float((px-self.playerdelta[0])*self.scale)
        py=float((py-self.playerdelta[1])*self.scale)        
        self.campos=[px,-py]    
        self._updatecamera(0)
        
    def _updatecamera(self,dt):                        
        cx,cy=self.campos
        px,py=self.playerpos
        px=float((px-self.playerdelta[0])*self.scale)
        py=float((py-self.playerdelta[1])*self.scale)        
        dx=px-cx
        dy=-py-cy
          
        s=dt*self.camspeed
        cx+=dx*s
        cy+=dy*s
        
        self.campos=[cx,cy]
        
        wx,wy=self.root.gui.windowsize            
        ar=float(wx)/wy
                  
        if wx>=wy:
            cx*=ar
            cy*=ar                
        else:
            cx/=ar            
        
        self.root.rootnp.setPos(-cx,cy,0)
    
    def _rescale(self,windowsize=None):        
        wx,wy=self.root.gui.windowsize
        s=self.scale
        ar=float(wx)/wy
        if wx>=wy:                                        
            s*=ar
        else:            
            s/=ar
        
        self.root.rootnp.setScale(s,s,1)    
            
        self._resetcamera()
        
        
    def setscale(self,scale):
        if scale<>self.scale:
            self.scale=scale
            self._rescale()
            
            
    def _resetgrid(self,size,layers):
        assert(size[0]>2 and size[1]>2)
        for layer in self._getlayerlist():
            for y in xrange(self.mapsize[1]):
                for x in xrange(self.mapsize[0]):
                    g=self.grid[layer][y][x]
                    if g<>None:
                        g.free()         
        self.grid={}
        for layer in layers:        
            self.grid[layer]=[[None for x in xrange(size[0])] for y in xrange(size[1])]
        
        
    def setmapsize(self,x,y):                    
        mapsize=[x,y]
        if mapsize<>self.mapsize:
            self._resetgrid(mapsize,self.grid.keys())       
            self.mapsize=mapsize
                
    def addlayer(self,name,sort):        
        pl=self._getlayerlist()
        assert(not name in pl)
        self._resetgrid(self.mapsize,pl+[name])
        
            
    def settileinsertcallback(self,cb):
        self.tileinsertcallback=cb
        
            
    def _onmouse(self,button,down):
        seltile=self.seltile
        
        if down:
            newpos=self.gridcursor
        
            if newpos<>None:

                if button==3:
                    t=self.grid[self.activelayer][newpos[1]][newpos[0]]
                    if t<>None:
                        seltile=self.gridcursor                                            
                        self.selcard.setPos(seltile[0],seltile[1],0)                                      
                    else:
                        seltile=None
                        
                        
                elif self._notinborder(*newpos):
                    if button==2 or (button==1 and self.levelkeys.iskeydown('x')):                                                 
                        self._deltile(newpos[0],newpos[1],self.activelayer) 
                        if newpos==seltile:                                                    
                            seltile=None
                    
                    elif button==1:
                        t=self.grid[self.activelayer][newpos[1]][newpos[0]]                           
                        px,py=self._gridtoworld(*newpos)
                        if self.seltile<>None:
                            sel=self.grid[self.activelayer][self.seltile[1]][self.seltile[0]]
                            if sel<>None:
                                if sel.singleton:                                    
                                    self._deltile(seltile[0],seltile[1],sel.layer)
                                    seltile=newpos
                                    self.selcard.setPos(seltile[0],seltile[1],0)    
                                else:
                                    #prevent adding tile equivalent to existing tile 
                                    if t<>None:
                                        if t.__class__==sel.__class__:
                                            if t.args==sel.args: 
                                                return
                        
                                self.addtile(newpos[0],newpos[1],sel.__class__.__name__,self.activelayer,sel.args)
                                
                            
                        else:                                
                            if self.seltileindex>=0:
                                t,layer,singleton,args=self.parent.parent.gettileclassdatafromindex(self.seltileindex)
                                if not singelton or not self._findfirstinstance(t):                                    
                                    self.addtile(newpos[0],newpos[1],t.__name__,self.activelayer,args)
                                
                                    
                                
                elif button==3:
                    seltile=None                 
                    self.selcard.hide()   
                    
                if seltile<>self.seltile:                    
                    if seltile:
                        self.selcard.show()
                    else:
                        self.selcard.hide()
                    self.notify('onseltilechange',(self.seltile,seltile))
                    self.seltile=seltile
                    
                
    def _deltile(self,gx,gy,layer):        
        t=self.grid[layer][gy][gx]                        
        if t<>None:            
            self.notify('ondeltile',t)
            t.free()            
            self.grid[layer][gy][gx]=None
            
                    
    def _screentoworld(self,px,py,pixel=False):
        wx,wy=self.root.gui.windowsize
        
        if pixel:
            px=(0.5*(px/wx-0.5))
            py=(0.5*(py/wy-0.5))      
                         
        ar=float(wx)/wy
        if wx>=wy:            
            px=(px*1.072+self.campos[0])/self.scale
            py=(py*1.072/ar-self.campos[1])/(self.scale)
        else:
            px=(px*1.072*ar+self.campos[0])/self.scale
            py=(py*1.072-self.campos[1]*ar)/(self.scale)
        
        px=round(px)
        py=round(py)
        
        return [px,py]
            
                
    def _onsim(self,dt):
        if self.editing and base.mouseWatcherNode.hasMouse() and self.root.gui.mouseobj in (self.parent.parent.leveleditor,None):
                        
            mx,my=self.root.gui.mousepos
            
            x,y=self._screentoworld(mx,my,True)  
            x=int(x)
            y=int(y)
            
            if not self._ingrid(x,y):                
                self.mousecard.hide()
                self.gridcursor=None
            else:
                self.gridcursor=[x,y]
                             
#                t=self.grid[self.activelayer][y][x]
#                if t<>None:
#                    print 'hovering over:',x,y,t
                
                if not self.root.gui.mousebuttons[0]:
                    if self.root.gui.mousebuttons[1] and (not self.root.gui.mousebuttons[2]):  
                        self._onmouse(2,True)
                    elif self.root.gui.mousebuttons[2] and (not self.root.gui.mousebuttons[1]):  
                        self._onmouse(3,True)
            
                elif (not self.root.gui.mousebuttons[1]) and (not self.root.gui.mousebuttons[2]):  
                    self._onmouse(1,True)
                
                    
                self.mousecard.show()
                self.mousecard.setPos(x,y,0)
                
        else:
            self.mousecard.hide()
            self.gridcursor=None
        
        if self.seltile<>None:        
            self.selblink+=self.selblinkspeed*dt
            a=math.sin(self.selblink)*0.5+0.5
            cs=(Vec4(0.6,0.8,1,1),Vec4(1,1,0.5,1))#[i]
            #self.selcard.setColor(c)
            self.selcard.setColor(cs[1]*a+cs[0]*(1.0-a))
        
            
        if self.enabled:
            self.notify('onlevelupdate',dt)
            self._resetplayeroffset()
            self._updatecamera(dt)
     
            
    def _adddynamicobj(self,obj):
        self.dynamicobjs.append(obj)
        
    def _deldynamicobj(self,obj):
        self.dynamicobjs.remove(obj)
        
            
    def setsimulating(self,simulating):
        if self.simulating<>simulating:
            self.simulating=simulating
            self.notify('onsimchange',simulating)
            
    def setplaystate(self,playstate):
        e=playstate=='edit' 
        p=playstate=='player'
        self.setediting(e)
        self.setenabled(e or p)
        self.setsimulating(p)
            
    def setediting(self,editing):
        if editing<>self.editing:
            self.editing=editing
            self.levelkeys.setenabled(self.enabled and editing)
           
            if editing:
                if self.seltile<>None:
                    self.selcard.show()    
            else:                
                self.selcard.hide()    
            self.notify('oneditingchange',editing)
                
    def setenabled(self,enabled):
        if self.enabled<>enabled:
            self.enabled=enabled        
            self.levelkeys.setenabled(enabled and self.editing)        
            
            
    def getgravity(self):
        return self.gravity
    
    def getplayerstart(self):
        return self.playerstart
        
    def _getwallcollision(self,px,py,sx,sy):
        layer='walls'
        x=int(round(px))
        y=int(round(py))
        dx=px-x
        dy=(py-y)        
        xd,xl=([-1,'left'],[1,'right'])[dx>=0]
        yd,yl=([-1,'down'],[1,'up'])[dy>=0]
        difx=-xd*abs(dx)
        dify=-yd*abs(dy)
        res={'hitsidex':('',None),'hitsidey':('',None),'colliders':[]}
        
        colxy=None   
        colx=None     
        
        intoy=(abs(sy)<0.002 or cmp(sy,0)==yd) #not a collision if moving away from 
        intox=(abs(sx)<0.002 or cmp(sx,0)==xd)
        
        if abs(dx)>0.0002:
            if intox:
                if self._ingrid(x+xd,y): #make sure speed is not heading away from side
                    t=self.grid[layer][y][x+xd]
                    if t<>None and (isinstance(t,(wallclass,exitblock))):# or (isinstance(t,graviblock) and t.solid)):                            
                        colx=True
                        res['hitsidex']=(xl,difx)
                        res['colliders'].append(t)
                            
            if abs(dy)>0.0002 and self._ingrid(x+xd,y+yd):
                t=self.grid[layer][y+yd][x+xd]
                if t<>None and isinstance(t,(wallclass,exitblock)):# or (isinstance(t,graviblock) and t.solid):
                    colxy=True            
                    if not colx:
                        if abs(dx)>abs(dy):            
                            res['hitsidey']=(yl,dify)
                        else:
                            res['hitsidex']=(xl,difx)                
                    res['colliders'].append(t)                    
                        

        if intoy and abs(dy)>0.0002 and self._ingrid(x,y+yd): #make sure speed is not heading away from side                    
            t=self.grid[layer][y+yd][x]
            if t<>None and (isinstance(t,(wallclass,exitblock))):# or (isinstance(t,graviblock) and t.solid)):
                if colxy:
                    if not colx:
                        res['hitsidex']=('',0)                    
                    
                    if abs(dx)<0.5:
                        res['colliders'].pop(-1)#remove the corner from the list of objects hit

                res['hitsidey']=(yl,dify)
                res['colliders'].append(t)                        
                                      
            elif len(res['colliders'])==2:
                if abs(dy)<0.5:
                    res['colliders'].pop(1)
                else:
                    res['colliders'].pop(0)
                                  
        return res
                        
                
    def collide(self,params):
        if params[0]=='player':
            px,py=params[1]
            self._setplayerpos([px,py])
            sx,sy=params[2]
            return self._getwallcollision(px,py,sx,sy)
            
        elif params[0]=='stone':            
            px,py=params[1]
            x,y=self._worldtogrid(px,py)
            if self._ingrid(x,y):
                t=self.grid['walls'][y][x]
                if t<>None:
                    if isinstance(t,wallclass):
                        return (None,t)[t.stonesolid]
                    elif isinstance(t,graviblock):
                        return (None,t)[t.solid]                    
                return t
            
        
    def reset(self):
        self._resetcamera()
        self.notify('onreset',None,False)        
    

    def _gridtoworld(self,x,y):
        return [x,y]
        
    def _worldtogrid(self,x,y):
        return [int(round(x)+0.5),int(round(y)+0.5)]
        
    def _notinborder(self,x,y):
        return x>0 and y>0 and x<self.mapsize[0]-1 and y<self.mapsize[1]-1
    
    def _ingrid(self,x,y):
        if x<0 or y<0: return False
        if x>=self.mapsize[0] or y>=self.mapsize[1]: return False
        return True
        
    def setgravity(self,gx,gy):
        self.gravity=gx,gy
    
    def setplayerstart(self,pos):
        if pos<>self.playerstart:
            self.playerstart=pos
        #assert(self._ingrid(x,y))
        #px,py=self._gridtoworld(x,y)
        #self.playerstart=px,py
        
#    def addgraviblock(self,x,y,dir=0,active=False,solid=True):
#        assert(self._ingrid(x,y))
#        t=self.grid[y][x]
#        assert(t==None)
#        px,py=self._gridtoworld(x,y)
#        gb=graviblock(self,[px,py],dir,active,solid)
#        self.grid[y][x]=gb
#        self.gravblocks.append(gb)
        

#    def setexitpos(self,x,y):
#        assert(self._ingrid(x,y))
#        t=self.grid[y][x]
#        assert(t==None)
#        px,py=self._gridtoworld(x,y)
#        self.grid[y][x]=exitblock(self,[px,py])

#    def addwall(self,x,y,solid=True):
#        assert(self._ingrid(x,y))
#        t=self.grid[y][x]
#        assert(t==None)
#        px,py=self._gridtoworld(x,y)
#        self.grid[y][x]=wallclass(self,[px,py],solid)

    def _getlayerlist(self):
        return self.grid.keys()

    def _findfirstinstance(self,cls):
        clsname=cls.__name__
        for layer in self._getlayerlist():
            for y in xrange(self.mapsize[1]):
                for x in xrange(self.mapsize[0]):                            
                    t=self.grid[y][x]
                    if t<>None:
                        if t.__class__.__name__==clsname:
                            return True

    def _onbeforeload(self):
        self.setmapsize(*self.defaultmapsize)        
        self.playerstart=[1,1]
        
    def _unloadlevel(self):
        levelclass._unloadlevel(self)        
        self._resetgrid([3,3],[])        
        self.mapsize=[3,3]
        self.gravblocks=[]
        
    def _gettilesatgrid(self,gx,gy):
        assert(self._ingrid(gx,gy))
        r=[]
        for layer in self._getlayerlist():
            g=self.grid[layer][gy][gx]
            if g<>None:
                r.append(g)
        return r
        
    def _addborderblocks(self):

        for y in xrange(self.mapsize[1]):
            for x in xrange(self.mapsize[0]):
                px,py=self._gridtoworld(x,y)
                if x==0 or y==0 or x==self.mapsize[0]-1 or y==self.mapsize[1]-1:      
                    self._deltile(x,y,'walls')
                    self.addtile(x,y,'wallclass','walls',{'stonesolid':True})
                #elif True:
                    #t=self._gettilesatgrid(x,y)
                    #if t==[]:
                    #self.addtile(x,y,'bgtileclass','bg')
                    
    def _onafterload(self):
        self._addborderblocks()        
        self._resetcamera()



    def _onfree(self):     
        
        levelclass._onfree(self)            
                
        
        for obj in self.dynamicobjs:
            obj.free()
        self.dynamicobjs=[]
        
        self.mousecard.removeNode()        
        self.mousecard=None
        
        self.selcard.removeNode()
        self.selcard=None
        
        self.root.gui.unbind('onresize',self._rescale) 
        self.root.unbind('onsim',self._onsim)             
        
        self.root.gui.unbind('onmouse1',self._onmouse)
        self.root.gui.unbind('onmouse2',self._onmouse)
        self.root.gui.unbind('onmouse3',self._onmouse)
               
  
         
        
class levelfeature(feature):
    def __init__(self,level):
        assert(isinstance(level,gamelevel))
        feature.__init__(self,level)  
        
        self.bind('onfree',self._onfree)
        
        self.parent.bind('onlevelupdate',self._update)        

    def _onfree(self):        
        self.parent.unbind('onlevelupdate',self._update)        
        
    def _update(self,dt):
        pass
        
    
    
class dynamiclevelfeature(levelfeature):
    def __init__(self,level,singleton=False):
        levelfeature.__init__(self,level) 
        
        
        
class tilevisual(feature):
    def __init__(self,parent):
        feature.__init__(self,parent)    
        
        self.tile=None
        
    def _attach(self,tile):
        assert(self.tile==None)
        self.tile=tile
        self._doattach()
        
    def _doremove(self): pass
    def _doattach(self): pass
            
    def _remove(self):
        self.tile=None
        self._doremove()
        
        
class tile(levelfeature):
    def __init__(self,level,startpos,layer='bg',singleton=False,args={}):
        levelfeature.__init__(self,level)
        self.startpos=startpos
        self.layer=layer
        self.singleton=singleton
        self.args=args
        
        self.visual=None
        
    def setvisual(self,visual):
        if visual<>self.visual:
            if self.visual<>None:
                self.visual._remove()
            self.visual=visual
            if visual<>None:
                visual._attach(self)
                
    def _onvisualfree(self):
        self.setvisual(None)
            
    def _onfree(self):
        levelfeature._onfree(self)
        self.setvisual(None)
        
        
class playerstart(tile):
    def __init__(self,level,startpos,layer,singleton,args):
        tile.__init__(self,level,startpos,layer,singleton,args)
   
        self.card=loadcard(self.root.layers[self.layer],pos=Vec3(startpos[0],startpos[1],0),scale=1,texture=PLAYERSTARTTEX,transparent=False,mipmap=True,autorotate=True)
        if not level.editing:
            self.card.hide()
        
        level.bind('oneditingchange',self._setvis)
        level.setplayerstart(self.startpos)


    def _onfree(self):
        tile._onfree(self)
        self.card.removeNode()
        self.parent.unbind('oneditingchange',self._setvis)

    def _setvis(self,vis):
        if vis:
            self.card.show()
        else:
            self.card.hide()


#class bgtileclass(tile):
#    def __init__(self,parent,startpos,layer,singleton,args):        
#        tile.__init__(self,parent,startpos,layer,singleton,args)          
      
#        self.card=loadcard(self.root.layers[self.layer],pos=Vec3(startpos[0],startpos[1],0),scale=1,texture=BGTILETEX,transparent=False,mipmap=True,autorotate=True)
        
        
#    def _onfree(self):
#        levelfeature._onfree(self)
#        self.card.removeNode()
#        self.card=None
        
   
        
class wallclass(tile):
    def __init__(self,parent,startpos,layer,singleton,args):        
        tile.__init__(self,parent,startpos,layer,singleton,args)          
        
        self.startpos=startpos
        
        self.stonesolid=self.args['stonesolid']
        
        self.card=loadcard(self.root.layers[self.layer],pos=Vec3(startpos[0],startpos[1],0),scale=1,texture=BLOCKTEXS[self.stonesolid],transparent=True,mipmap=True,autorotate=True)
  
    def setsolid(self,solid):
        if self.stonesolid<>solid:
            self.stonesolid=solid
            self.card.setTexture(BLOCKTEXS[solid])
        
    def _onfree(self):
        levelfeature._onfree(self)
        self.card.removeNode()
        self.card=None

           
    
    
class exitblock(tile):
    def __init__(self,parent,startpos,layer,singleton,args):              
        tile.__init__(self,parent,startpos,layer,singleton=True,args=args)  
        
        self.card=loadcard(self.root.layers[self.layer],pos=Vec3(startpos[0],startpos[1],0),texture=EGGTEX,transparent=False,mipmap=True,autorotate=True)
        
          
    def _onfree(self):
        levelfeature._onfree(self)
        self.card.removeNode()
        self.card=None
      
        
        
#class graviblock(tile):
#    def __init__(self,parent,startpos,layer,singleton,args):        
#        tile.__init__(self,parent,startpos,layer,singleton,args)
#        self.bind('activate',self.toggleactive)    
#        parent.bind('onreset',self._reset)  
        
#        #dir=0,active=False,solid=True,size=1
        
#        self.startactive=self.args['active']
#        self.active=self.startactive
#        #self.startpos=startpos
#        self.solid=self.args['solid']
#        self.dir=self.args['dir']                
        
         
#        self.card=loadcard(self.root.layers['bg'],pos=Vec3(startpos[0],startpos[1],0),scale=size,texture=GRAVBLOCKTEXS[self.solid],transparent=False,mipmap=True,autorotate=True)
#        self.card2=loadcard(self.card,texture=ARROWTEXS[active],transparent=True,mipmap=True,autorotate=False)
#        self.card2.setR(90*dir)
        
        
#    def _reset(self):
#        self.setactive(self.startactive)
        
        
#    def setsolid(self,solid):
#        if self.solid<>solid:
#            self.solid=solid
#            self.card.setTexture(GRAVBLOCKTEXS[solid])
                
        
#    def setdir(self,dir):
#        dir=dir%4
#        if dir<>self.dir:
#            self.card2.setR(90*dir)
        
#    def toggleactive(self):
#        self.setactive(not self.active)
        
#    def setactive(self,active):
#        if self.active<>active:
#            self.active=active            
#            self.card2.setTexture(ARROWTEXS[active])            
        
#    def _onfree(self):
#        levelfeature._onfree(self)
#        self.card.removeNode()
#        self.card=None
        
    
        
DIRS2D=[(0,1),(1,0),(0,-1),(-1,0)]
        
class featherclass(levelfeature):
    def __init__(self,parent,startpos,dir,size=0.3):
        levelfeature.__init__(self,parent)  
        parent.bind('onreset',self.free)
        parent.bind('onfree',self.free)
        
        self.size=size

        self.gravity=parent.gravity#[0,2]
        self.speed=[0,0]
        self.pos=startpos

        self.startpos=startpos
        
        self.dir=dir
        self.dirs=DIRS2D[dir]
        
        self.simspeed=150
                
        self.speed=[self.dirs[0]*5,self.dirs[1]*5]
         
        self.card=loadcard(self.root.layers['feathers'],pos=Vec3(self.startpos[0],self.startpos[1],0),scale=Vec3(size*1.5,size,1),texture=FEATHERTEX,transparent=True,mipmap=True,autorotate=True) 
        self.card.setH(-90*dir+180)
        
    def _getbounds(self,px,py):
        return [px-self.size*0.5,px+self.size*0.5,py-self.size*0.5,py+self.size*0.5]
  

    def _update(self,dt):
        px,py=self.pos
        
        sx,sy=self.speed
        
        sx+=self.gravity[0]*dt
        sy+=self.gravity[1]*dt          
        
        self.speed=[sx,sy]
        
        px+=sx*dt*self.simspeed*dt
        py+=sy*dt*self.simspeed*dt
        
        self.pos=[px,py]
        
        bounds=self._getbounds(px,py)
        
        r=self.parent.collide(('stone',[px,py]))
            
        if r<>None: #and not isinstance(r,(bgblockclass)):
            #if isinstance(r,graviblock):
            #    r.notify('activate',None,False)                      
            self.free()
        else:
            self.card.setPos(px,py,0)
            
            a=math.atan2(sy,sx)*180.0/3.14159
            self.card.setH(a+90)
           
    def _onfree(self):   
        levelfeature._onfree(self)     
        self.card.removeNode()
        self.card=None
        
        

class levelmgr(feature):
    def __init__(self,parent):
        feature.__init__(self,parent)            
        self.bind('onfree',self._onfree)
        
        self.levelname=''
        self.level=None

    def setlevel(self,levelname):
        if levelname<>self.levelname:
            self.levelname=levelname
            if self.level<>None:
                self.level.free()
            if levelname<>'':
                self.level=gamelevel(self,levelname)
                self.level.load()
            else:
                self.level=None
        

    def _onfree(self):
        self.setlevel('')


 
class playerclass(feature):
    def __init__(self,parent,startpos=[0,0],scale=1):
        feature.__init__(self,parent)  
        self.bind('onfree',self._onfree)
        self.root.bind('onsim',self._update)

        self.scale=scale

        self.movekeys=keybinder(self)
        self.movekeys.addkey('w')
        self.movekeys.addkey('a')
        self.movekeys.addkey('s')
        self.movekeys.addkey('d')        
        self.movekeys.addkey('space')        
        self.movekeys.bind('onkeydown-w',self._jump)                    
        self.movekeys.bind('onkeydown-space',self._jump)                    

        arrows=[('up',0),('down',2),('left',3),('right',1)]
        for dir,d in arrows:
            self.movekeys.addkey('arrow_'+dir)
            self.movekeys.bind('onkeydown-arrow_'+dir,self._shootfeather,d,True)                
        

        self.startpos=startpos
    
        self.card=loadcard(self.root.layers['player'],pos=Vec3(self.startpos[0],0,self.startpos[1]),scale=scale,texture=HENTEXS[0],transparent=True,mipmap=True,autorotate=True)
        self.card.setTwoSided(True)
        
        self.gravity=[0,0]
        self.accelspeed=0.6
        self.simspeed=10
       
        self.speed=[0,0]
        self.pos=self.startpos
        
        self.gravblockpower=0.04
        
        self.enabled=True
        
        self.standing=False
        
        self.friction=0.92
        self.jumpspeed=0.2
        self.jumpsleft=0
        self.maxjumps=4
        self.maxspeed=[0.5,0.5]
        
        self.animpos=0
        self.animspeed=0.3
        self.animframe=0
        
        self.walljump=True
               
    def _shootfeather(self,dir):        
        featherclass(self.parent.levelmgr.level,self.pos,dir)
    
    def _jump(self):
        if self.jumpsleft>0:        
            self.jumpsleft-=1
            self.speed[1]=self.jumpspeed*4.0*self.jumpsleft/self.maxjumps
            
            
        
    def setgravity(self,gx,gy):
        self.gravity=[gx*1.5,gy*1.5]    
        
    def setenabled(self,enabled):    
        if self.enabled<>enabled:
            self.enabled=enabled
            self.movekeys.setenabled(enabled)
            #self.notify('onpausechange',paused)
    
    def setstartpos(self,startpos):
        self.startpos=startpos
        
    def reset(self):
        self.speed=[0,0]

        self.pos=self.startpos
        self.card.setPos(self.pos[0],0,self.pos[1])
           
    def _update(self,dt):
        if self.enabled:
            u=self.movekeys.iskeydown('w')
            d=self.movekeys.iskeydown('s')
            l=self.movekeys.iskeydown('a')
            r=self.movekeys.iskeydown('d')
            
            gliding=False
            if u and not d or self.movekeys.iskeydown('space'):
                gliding=True
           
            if d and not u:
                self.speed[1]-=self.accelspeed*dt*5            
                        
            if l and not r:
                self.speed[0]-=self.accelspeed*dt*5
            elif r and not l:
                self.speed[0]+=self.accelspeed*dt*5
            
            
            if self.enabled:
                self.speed[0]+=self.gravity[0]*dt
                self.speed[1]+=self.gravity[1]*dt
                
                for gb in self.parent.levelmgr.level.gravblocks:
                    if gb.active:
                        dirs=[('y',1),('x',1),('y',-1),('x',-1)]
                        da,dv=dirs[gb.dir]
                        if da=='y':
                            dx=gb.startpos[0]-self.pos[0]
                            if abs(dx)<1:
                                self.speed[1]+=self.gravblockpower*dv
                        else:
                            dy=gb.startpos[1]-self.pos[1]
                            if abs(dy)<1:
                                self.speed[0]+=self.gravblockpower*dv
                
                opx,opy=self.pos
                vx,vy=self.speed
                vx+=self.speed[0]*self.accelspeed*dt
                vy+=self.speed[1]*self.accelspeed*dt
                
                if self.standing and not ((l and not r) or (r and not l)):
                    vx*=self.friction            
                elif gliding:
                    if vy<0:
                        vy*=0.94
                    else:
                        vy*=1.02
                              
                if vx<0:
                    if vx<-self.maxspeed[0]:
                        vx=-self.maxspeed[0]                                
                else:
                    if vx>self.maxspeed[0]:
                        vx=self.maxspeed[0]                                
                
                if vy<0:
                    if vy<-self.maxspeed[1]:
                        vy=-self.maxspeed[1]                    
                else:                
                    if vy>self.maxspeed[1]:
                        vy=self.maxspeed[1]
                             
                                                                    
                self.speed=[vx,vy]
                
                px=opx+vx*self.simspeed*dt
                py=opy+vy*self.simspeed*dt        

                c=self.parent.levelmgr.level.collide(('player',[px,py],self.speed))
                
                if c<>None:                
                    for i in c['colliders']:
                        if isinstance(i,exitblock):                        
                            self.parent.passlevel()
                            return            
                        
                        #else: #todo-delete this
                        #    i.card.setH(random.randint(-20,20))
                            
                            
                    standx=False #todo - delete this wall jumping 
                            
                    hx=c['hitsidex']
                    if hx[0]<>'':
                        px+=hx[1]
                        self.speed[0]=0    
                        if not self.standing and self.walljump: #todo - delete this wall jumping 
                            self.standing=True  
                            self.jumpsleft=self.maxjumps
                            standx=True           
                            self.notify('onwallland',hx[1])                        
                            
                    hy=c['hitsidey']
                    if hy[0]<>'':
                        py+=hy[1]
                        self.speed[1]=0
                        
                        if hy[1]>0:                                                                             
                            if not self.standing:                       
                                self.notify('onland',hy[1])
                            self.standing=True
                            self.jumpsleft=self.maxjumps  
                        else:
                            self.notify('onheadbut',hy[1])
                                
                    elif self.standing:
                        if not self.walljump or (self.walljump and not standx):#todo - delete this wall jumping 
                            self.standing=False
                            self.notify('onjump',None,False)

                if self.standing:                                                                    
                    self.animpos+=abs(vx)*self.animspeed
                    a=int(self.animpos)%2
                    if a<>self.animframe:
                        self.animframe=a
                        self.card.setTexture(HENTEXS[a])
                            
                self.pos=[px,py]

                s=self.scale
                scalex=(-s,s)[(vx>=0 and not (l and not r)) or (r and not l)]            
                self.card.setScale(scalex,1,s)    
                        
                self.card.setPos(px,py,0)

    def _onfree(self):
        self.root.unbind('onsim',self._update)        
        self.card.removeNode()
        self.card=None
        
        
        
        


class gameclass(feature):
    def __init__(self,parent):
        feature.__init__(self,parent)
        self.root.bind('onfree',self._onfree)
        #self.enabled=False

            
                 
 

        self.levelmgr=levelmgr(self)

         
        #self.parent.bind('ondisabled',self._setenabled,False,True)
        #self.parent.bind('onenabled',self._setenabled,True,True)

        self.gamekeys=keybinder(self)
    
        self.gamekeys.addkey('r')        
        self.gamekeys.bind('onkeydown-r',self.resetlevel) 
        self.gamekeys.addkey('backspace')        
        self.gamekeys.bind('onkeydown-backspace',self.startprevlevel) 
        self.gamekeys.addkey('enter')        
        self.gamekeys.bind('onkeydown-enter',self.startnextlevel) 
            
        self.player=None
        
        self.playmode=None
        
        
        self.tileset={}       
        
        self._adddefaulttileset()
        
        
        self.curlevel=0
        self.startnextlevel()
        
        
        self.leveleditor=leveleditor(self).init()
        
        def _savelevel(self=self):            
            self.levelmgr.level.save()
            
        self.leveleditor.savebutton.bind('onclick',_savelevel)
        
               
        self.mainmenu=mainmenu(self).init() 
                
        self.setplaymode('mainmenu')
        
        
       
    def _adddefaulttileset(self):
        _renderlayers=('bg','walls','player','feathers','mouse')      
        for l in _renderlayers:
            self.root.addlayer('render',l)        
                
#        _hudlayers=('hud',)
#        for l in _hudlayers: 
#            self.root.addlayer('hud',l)    
        
        self.addtiletoset(playerstart,'player',True,{})
        self.addtiletoset(wallclass,'walls',False,{'stonesolid':True})        
        self.addtiletoset(exitblock,'walls',True,{})
        #self.addtiletoset(graviblock,'walls',False,{'active':False,'solid':True,'dir':0})
        #self.addtiletoset(bgtileclass,'bg',False,{})
          
    def addtiletoset(self,tileclass,layer,singleton,args={}): 
        clsname=tileclass.__name__       
        assert(not args==None)
        index=len(self.tileset)
        self.tileset[clsname]=(index,tileclass,layer,singleton,args)
        
  

    def gettileclassdata(self,clsname):
        if not clsname in self.tileset:
            raise Exception('error locating tile class: '+clsname)
        
        t=self.tileset[clsname]
        return t[1:]
                
    def gettileclassdatafromindex(self,index):
        r=None
        for t in self.tiles.values():
            if t[0]==index:
                r=t[1:]
                break
        if r==None:
            raise Exception('error: index not found: '+str(index))
     
    
    def setplaymode(self,mode):        
        if hasattr(self,'mainmenu'):
            if mode<>self.playmode:            
                self.playmode=mode
                player=mode=='player'
                editor=mode=='edit'
                mainmenu=mode=='mainmenu'
                self.leveleditor.setvisible(editor)              
                self.levelmgr.level.setplaystate(mode)
                self.player.setenabled(player)
                self.mainmenu.setvisible(mainmenu)
                self.mainmenu.setenabled(player or mainmenu)
                self.leveleditor.setenabled(player or editor)
                self.gamekeys.setenabled(player)
    
    def _onfree(self):
        self.mainmenu.free()
        self.leveleditor.free()
        self.player.free()
        self.gamekeys.free()
        self.tileset={}
        
    def passlevel(self):
        self.startnextlevel()
        
    def resetlevel(self):
        self.levelmgr.level.reset()
        self.player.reset()
            
    
    def startprevlevel(self):        
        if self.curlevel>1:
            self.curlevel-=2
            self.startnextlevel()        
   
    def startnextlevel(self):        
        if self.player<>None:
            self.player.setenabled(True)
        self.curlevel+=1
        self.levelmgr.setlevel('level'+str(self.curlevel))
        if self.player==None:
            self.player=playerclass(self)        
        self.player.setstartpos(self.levelmgr.level.getplayerstart())
        self.player.setgravity(*self.levelmgr.level.getgravity())
        self.player.reset()        
     
           
    def _shoot(self,dir):
        featherclass(self.levelmgr.level,self.player.pos,dir)
        
          
  
        

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
class buttongrid(widget):
    #button clicks raise onbuttonclick event of this
    def __init__(self,parent,buttons,showlabels=False,squareside='',frameargs={},widgetargs={},labelargs={},buttonstyle=BUTTONSTYLE1,clickstyle='radio',buttoncursor=None):
        widget.__init__(self,parent,**widgetargs)
        self.buttondata=buttons
        self.buttons={}
        self.showlabels=showlabels
        self.clickstyle=clickstyle
        self.labelargs=labelargs
        self.buttonstyle=buttonstyle
        self.frameargs=frameargs
        self.buttoncursor=buttoncursor        
        self.squareside=squareside
        
        self._initbuttons()
        
    def _freebuttons(self):
        for txt,button in self.buttons.iteritems():
            button.free()
        self.buttons={}
        
    def _addbutton(self,text,side='x'):        
        self.freebuttons()
        if side=='x':
            self.buttondata[-1].append(text)
        else:
            self.buttondata.append([text])
        self._initbuttons()
        
    def _initbuttons(self):
        buttons=self.buttondata
        
        gridsize=[len(buttons),len(buttons[0])]
                    
        for b in xrange(1,len(buttons)):
            assert(len(buttons[b])==gridsize[1])
                            
        if self.squareside=='y':
            sx=float(100)/gridsize[0]
            sy=-sx
        elif self.squareside=='x':        
            sy=float(100)/gridsize[1]                
            sx=-sy
        else:
            sx=float(100)/gridsize[0]
            sy=float(100)/gridsize[1]
                            
        wa={'layout':[sx,sy],'size':[0,0],'pos':[0,0]}      
        if self.buttoncursor<>None:
            wa['cursor']=self.buttoncursor
        
        rg=(None,'group')[self.clickstyle=='radio']    
            
        for y in xrange(gridsize[1]):
            for x in xrange(gridsize[0]):                
                s=str(x)+'-'+str(y)                
                txt=buttons[x][y]
                if isinstance(txt,(tuple,list)):
                    txt=txt[0]
                    img=txt[1]
                else:
                    img=None
                tex=(None,txt)[self.showlabels]
                
                b=button(self,text=tex,image=img,clickstyle=self.clickstyle,radiogroup=rg,labelargs=self.labelargs,buttonstyle=self.buttonstyle,frameargs=self.frameargs,widgetargs=wa).init()
                self.buttons[txt]=b        
                def _onframeresize(size,self=self,b=b,x=x,y=y):
                    b.setpos([size[0]*x,size[1]*y])
                    
                b.bind('onbuttonclick',self.notify,txt,True)
                        
                b.bind('onresize',_onframeresize)
                

                
        if self.clickstyle=='radio':
            self.buttons[buttons[0][0]].setpressed(True)
            
       
            
            
            
            
            
            
            
            
            
class leveleditor(keymenu):
    def __init__(self,parent,key='1',toggle=False):
        frameargs={'bordersize':0,
                   'borders':BORDERS32,
                   'bgcolor':VBase4(0.3,0.6,1,0),
                   'bordercolor':VBase4(0.3,0.6,1,0),
                   }
        widgetargs={'layout':layoutclass('mc',[100,100]),                   
                   'size':[0,0],                   
                   'zbias':10,
                   }
        keymenu.__init__(self,parent,key,toggle,frameargs,widgetargs) 
        
        self.title=label(self,text='Level Editor',widgetargs={'layout':'nc','size':[30,30],'pos':[15,7]},align='center').init()
     
        self.closelabel=label(self,text='Press '+self.key+' to Toggle this Window',widgetargs={'layout':'nw','size':[16,16],'pos':[19,12]},align='left').init()
     
        
        self.topframe=frame(self,bordersize=0,borders=BORDERS16,bordercolor=Vec4(0,0,0,0),bgcolor=Vec4(0,0,0,0),
                                    widgetargs={'layout':layoutclass('ne',[100,0]),'size':[0,60],'pos':[0,30]},
                                    ).init()

        self.leftframe=frame(self,bordersize=0,borders=BORDERS16,bordercolor=Vec4(0,0,0,0),bgcolor=Vec4(0,0,0,0),
                             widgetargs={'layout':layoutclass('sw',[0,100]),'size':[90,-90-30],'pos':[0,30]}).init()
                               
        self.rightframe=frame(self,bordersize=0,borders=BORDERS16,bordercolor=Vec4(0,0,0,0),bgcolor=Vec4(0,0,0,0),
                             widgetargs={'layout':layoutclass('se',[0,100]),'size':[30,-90-30],'pos':[0,30]}).init()
                               

        self.bottomframe=frame(self,bordersize=0,borders=BORDERS16,bordercolor=Vec4(0,0,0,0),bgcolor=Vec4(0,0,0,0),
                                    widgetargs={'layout':layoutclass('se',[100,0]),'size':[0,30],'pos':[0,0]},
                                    ).init()
                                                                     
        bs=copydict(BUTTONSTYLE1)
        bs[BDOWN]['bg']=VBase4(1,1,0.5,1)
        bs[BDOWN]['fg']=VBase4(0,0,0,1)
        bs[BHOVER]['bg']=VBase4(0.5,0.9,0.5,1)
                                    
#        self.buttonsleft=buttongrid(self.leftframe,[['Button1','Button2','Button3','Button4','Button5']],squareside='y',frameargs={'bordersize':3,'borders':BORDERSSHADOW64,'bordercolor':Vec4(1,1,1,0.6),'bgcolor':Vec4(1,1,1,0.6)},                          
#                          widgetargs={'layout':layoutclass('sw',[100,100]),'size':[0,0],'pos':[0,0]},
#                          buttonstyle=bs,
#                          labelargs={'align':'center','widgetargs':{'layout':layoutclass('nc',[-50,50]),'size':[0,0],'pos':[7+5,-1+3+10]}},
#                          ).init()
                                  
#        self.buttonsright=buttongrid(self.rightframe,[['Button1','Button2','Button3','Button4','Button5']],squareside='y',frameargs={'bordersize':3,'borders':BORDERSSHADOW64,'bordercolor':Vec4(1,1,1,0.6),'bgcolor':Vec4(1,1,1,0.6)},                          
#                          widgetargs={'layout':layoutclass('sw',[100,100]),'size':[0,0],'pos':[0,0]},
#                          buttonstyle=bs,
#                          labelargs={'align':'center','widgetargs':{'layout':layoutclass('nc',[-50,50]),'size':[0,0],'pos':[7+5,-1+3+10]}},
#                          ).init()
            
#        self.buttonstop=buttongrid(self.topframe,[['Button1'],['Button2'],['Button3'],['Button4'],['Button5'],['Button6'],['Button7'],['Button8']],squareside='x',frameargs={'bordersize':3,'borders':BORDERSSHADOW32,'bordercolor':Vec4(1,1,1,0.6),'bgcolor':Vec4(1,1,1,0.6)},                          
#                          widgetargs={'layout':layoutclass('sw',[90,100]),'size':[0,0],'pos':[0,0]},
#                          buttonstyle=bs,
#                          labelargs={'align':'center','widgetargs':{'layout':layoutclass('nc',[-50,50]),'size':[0,0],'pos':[7+5,-1+3+10]}},
#                          ).init()
   
                          
#        self.buttonsbottom=buttongrid(self.bottomframe,[['Button1'],['Button2'],['Button3'],['Button4'],['Button5'],['Button6'],['Button7'],['Button8']],squareside='x',frameargs={'bordersize':3,'borders':BORDERSSHADOW32,'bordercolor':Vec4(1,1,1,0.6),'bgcolor':Vec4(1,1,1,0.6)},                          
#                          widgetargs={'layout':layoutclass('sw',[90,100]),'size':[0,0],'pos':[0,0]},
#                          buttonstyle=bs,
#                          labelargs={'align':'center','widgetargs':{'layout':layoutclass('nc',[-50,50]),'size':[0,0],'pos':[7+5,-1+3+10]}},
#                          ).init()
                                  
            
        self.savebutton=button(self.topframe,text='Save Level',                              
                               #buttonstyle=bs, 
                               labelargs={'align':'left','widgetargs':{'layout':layoutclass('nw',[-55,55]),'size':[0,0],'pos':[7+5,-1+3]}},
                               frameargs={'bordersize':6,'borders':BORDERS16},
                               widgetargs={'layout':'nw','size':[45+80+15-11,33+16-8],'pos':[0,19-8+4]},
                               ).init()    

                                                 

        
        self.setvisible(False)       
        

    def _onsetvisible(self,visible):
        if visible:
            self.parent.setplaymode('edit')
        else:
            self.parent.setplaymode('player')
   

class mainmgr(feature):
    def __init__(self,parent):
        feature.__init__(self,parent)
        
                   

        self.game=gameclass(self)


class game(gamebase):
    def __init__(self):
        gamebase.__init__(self,'Mother Feather Plucker')
        
     
        self.mainmgr=mainmgr(self)
        
        self.run()
        
 

def start():
    game()        
    
if __name__=='__main__':
    start()
    
    
    
    
   
    
    
#todo:

#level editor:

    #layer mgr:
        #like psp, 

    #animations:
        #get their own manager dialog
        #are referenced by pieces

    #grid pieces:
        #wall piece:
            #parameters:
                #textures:list,solid:bool,offset:float

        #piece class selection dialog        
            #sections:
               #builtin classes
               #extension classes:
                    #
               #reference classes:
                    #uses a class or reference class of your choosing with the ability to override selected parameters 
                    #can reference any piece class (including its parameter editor with the addition of an added default button for each parameter which will only be enabled if the value is not the default
                    #gets disabled when the class it references disappears
                    #while disabled it can be reconnected to a class manually with a notification of any parameter defaults that will be removed because are no longer found by name.
                    
            
            
        #-have only one grid origin but may be of any integer positive any size (2d) and allows the level to be 
        #paint mode uses the left mouse button for paintting selected class 1, 

        #when a new class is added by the class editor the editor will know to provide that as an option to the grid piece selector window

    #level reference:
        #grid origin is lower left and the bounds may extend up and to the right with 2 integers
        #on collision with player and based on the newlevel/oldlevel area group name, send the old level an onareaexit event and the new one an onareaenter event
        #connecting references to each other and assigning groups 

#future: quadtree widget with method colliderect() to return which if any objects (in each direction) were hit and by how far in

#"Reference level" level piece, ensure it resizes properly on piece resize

#boss level:
#robotic farmer throwing fireballs
#has a door atop a block which must be shot several times to open
#inside will be a cut-scene for story and the farmer will get away
    
#level 1 - Escape from the barn

#level 2 - 

#+ player notifies objects of being hit, objects respond
#+ level file as data of visuals and blocks
#+ dynamiclevel objects
